--- src/VBox/Devices/PC/BIOS/rombios.c.orig	2009-12-17 23:27:47.000000000 +0900
+++ src/VBox/Devices/PC/BIOS/rombios.c	2010-03-10 00:46:25.000000000 +0900
@@ -9107,6 +9107,34 @@
 ;- INT18h -
 ;----------
 int18_handler: ;; Boot Failure routing
+#ifdef VBOX
+  ;; reset SP, SS, DS, ES
+  cli
+  mov  ax, #0xfffe
+  mov  sp, ax
+  xor  ax, ax
+  mov  ds, ax
+  mov  es, ax
+  mov  ss, ax
+  sti
+
+  ;; adjust return address
+  push bp
+  mov  bp, sp
+
+  ;; jump to next device
+  mov ax, 0x472
+  cmp ax, #0x0001
+  jz int19_2nd
+  cmp ax, #0x0002
+  jz int19_3rd
+  cmp ax, #0x0003
+  jz int19_4th
+
+  ;; no more next device
+  pop bp
+int18_handler_halt:
+#endif /* VBOX */
   call _int18_panic_msg
   hlt
   iret
@@ -9148,6 +9176,9 @@
 
   ;; 1st boot device
   mov  ax, #0x0001
+#ifdef VBOX
+  mov 0x472, ax
+#endif /* VBOX */
   push ax
   call _int19_function
   inc  sp
@@ -9158,8 +9189,14 @@
   test       ax, ax  ;; if ax is 0 try next boot device
   jnz        boot_setup
 
+#ifdef VBOX
+int19_2nd:
+#endif /* VBOX */
   ;; 2nd boot device
   mov  ax, #0x0002
+#ifdef VBOX
+  mov 0x472, ax
+#endif /* VBOX */
   push ax
   call _int19_function
   inc  sp
@@ -9167,8 +9204,14 @@
   test       ax, ax  ;; if ax is 0 try next boot device
   jnz        boot_setup
 
+#ifdef VBOX
+int19_3rd:
+#endif /* VBOX */
   ;; 3rd boot device
   mov  ax, #0x0003
+#ifdef VBOX
+  mov 0x472, ax
+#endif /* VBOX */
   push ax
   call _int19_function
   inc  sp
@@ -9177,15 +9220,25 @@
   test       ax, ax  ;; if ax is 0 try next boot device
   jnz        boot_setup
 
+#ifdef VBOX
+int19_4th:
+#endif /* VBOX */
   ;; 4th boot device
   mov  ax, #0x0004
+#ifdef VBOX
+  mov 0x472, ax
+#endif /* VBOX */
   push ax
   call _int19_function
   inc  sp
   inc  sp
 #endif /* VBOX */
   test       ax, ax  ;; if ax is 0 call int18
+#ifdef VBOX
+  jz         int18_handler_halt
+#else
   jz         int18_handler
+#endif /* VBOX */
 
 boot_setup:
   mov dl,    bl      ;; set drive so guest os find it
